#include <webcap/util.h>
#include <webcap.h>

#include <Xm/MessageB.h>
#include <X11/Intrinsic.h>

/* $Id: util.c 12 2023-02-12 11:01:13Z nishi $ */

#include <curl/curl.h>

#include <stdbool.h>
#include <stdlib.h>
#include <sys/utsname.h>

char* sstrcat(const char* str1, const char* str2){
	char* result = malloc(strlen(str1) + strlen(str2) + 1);
	result[strlen(str1) + strlen(str2)] = 0;	
	strcpy(result, str1);
	strcpy(result + strlen(str1), str2);
	return result;
}

char* sstrdup(const char* str){
	char* result = malloc(strlen(str) + 1);
	result[strlen(str)] = 0;
	strcpy(result, str);
	return result;
}

bool sstartswith(const char* target, const char* starts_with){
	if(strlen(starts_with) > strlen(target)) return false;
	int i;
	for(i = 0; starts_with[i] != 0; i++){
		if(starts_with[i] != target[i]) return false;
	}
	return true;
}

void RemoveButton(Widget w, int button){
	Widget remove;
	remove = XmMessageBoxGetChild(w, button);
	XtUnmanageChild(remove);
}

char* webcap_useragent(){
	char* result = sstrcat("E3T_WebCap/", WEBCAP_VERSION);
	char* tmp;
	tmp = result;
	result = sstrcat(tmp, " (");
	free(tmp);
#ifdef _X11_XLIB_H_
	tmp = result;
	result = sstrcat(tmp, "X11;");
	free(tmp);
#endif
#ifdef __unix__
	struct utsname* uts = malloc(sizeof(*uts));
	uname(uts);
	tmp = result;
	result = sstrcat(tmp, uts->sysname);
	free(tmp);
	tmp = result;
	result = sstrcat(tmp, " ");
	free(tmp);
	tmp = result;
	result = sstrcat(tmp, uts->release);
	free(tmp);
	tmp = result;
	result = sstrcat(tmp, " ");
	free(tmp);
	tmp = result;
	result = sstrcat(tmp, uts->machine);
	free(tmp);
	free(uts);
#endif
	tmp = result;
	result = sstrcat(tmp, ") ");
	free(tmp);
#ifndef __OLD_WWW__
	tmp = result;
	result = sstrcat(tmp, "libcurl/");
	free(tmp);
	tmp = result;
	result = sstrcat(tmp, LIBCURL_VERSION);
	free(tmp);
#else
	tmp = result;
	result = sstrcat(tmp, "WebCapWWW/1.00");
	free(tmp);
#endif
	return result;
}
